/*
 *  main.c
 *
 *  Stopwatch-Hauptprogramm
 *
 *  (C) 10/1996 Tilman Kuepper (tilman@tilli.tng.oche.de)
 */


#include "forms.h"
#include "stopwatch.h"
#include "browser.h"


/* RCS-Infos */
static char RCSdat[]="$Date: 1996/10/16 16:42:32 $";
static char RCSrev[]="$Revision: 2.5 $"; 
static char RCSsta[]="$State: Rel $";


/* (C)-Meldung */
#define COPYRIGHT "(C) 10/1996 Tilman Kuepper (tilman@tilli.tng.oche.de)"


/*
 *  Hauptprogramm
 */
void main(int argc, char *argv[])
{
    FD_f_stopwatch *f_stopwatch; /* Stopwatch-Dialog */
    FD_f_browser *f_browser; /* Browser-Dialog */
    
    /* Toolkit initialisieren */
    fl_initialize(&argc, argv, "Stopwatch", 0, 0);
    
    /* Vielleicht moechte jemand die Version wissen? */
    if(argc!=1)
    {
	/* RCS-Infos ausgeben */
	fprintf(stderr,"%s\n\n",COPYRIGHT);
	fprintf(stderr,"%s\n%s\n%s\n",RCSrev,RCSsta,RCSdat);
	
	fl_finish();
	exit(0);
    }
    
    /* Browser erzeugen */
    f_browser=create_form_f_browser();
    f_browser->b_clear->u_vdata=f_browser; /* Form fuer Callbacks merken */
    f_browser->b_print->u_vdata=f_browser;
    f_browser->b_hide->u_vdata=f_browser;
    fl_deactivate_object(f_browser->b_print); /* Liste ist noch leer! */
    fl_set_object_lcol(f_browser->b_print,FL_INACTIVE_COL);
    
    /* Schrift im Browser einstellen */
    fl_set_browser_fontsize(f_browser->br_list,FL_LARGE_SIZE);
    fl_set_browser_fontstyle(f_browser->br_list,FL_FIXEDBOLD_STYLE);
    
    /* Umrandungen etwas duenner machen */
    fl_set_object_bw(f_browser->box,-2);
    fl_set_object_bw(f_browser->b_clear,-2);
    fl_set_object_bw(f_browser->b_print,-2);
    fl_set_object_bw(f_browser->b_hide,-2);
    fl_set_object_bw(f_browser->br_list,-2);
    
    /* Stopwatch-Form erzeugen */
    f_stopwatch=create_form_f_stopwatch();
    fl_deactivate_object(f_stopwatch->b_stop); /* STOP-Knopf ist noch inaktiv */
    fl_set_object_lcol(f_stopwatch->b_stop,FL_INACTIVE_COL);
    f_stopwatch->b_start->u_vdata=f_stopwatch; /* Form merken fuer Callbacks */
    f_stopwatch->b_stop->u_vdata=f_stopwatch;
    f_stopwatch->b_list->u_vdata=f_browser; /* LIST-Knopf oeffnet Browser */
    
    /* Umrandungen etwas duenner machen */
    fl_set_object_bw(f_stopwatch->box,-2);
    fl_set_object_bw(f_stopwatch->f_time,-2);
    fl_set_object_bw(f_stopwatch->b_start,-2);
    fl_set_object_bw(f_stopwatch->b_stop,-2);
    fl_set_object_bw(f_stopwatch->b_list,-2);
    fl_set_object_bw(f_stopwatch->b_reset,-2);
    fl_set_object_bw(f_stopwatch->b_quit,-2);
    
    /* Uhr anzeigen */
    fl_show_form(f_stopwatch->f_stopwatch,FL_PLACE_FREE,FL_FULLBORDER,argv[0]);
    fl_do_forms();
    
    /* 
     * Die folgende Zeile sollte nie zur Ausfuehrung kommen, da das Programm
     * ueber einen Callback verlassen wird.
     */
    fl_hide_form(f_stopwatch->f_stopwatch);
}

